# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define bname   txw2
%define cvsdate 20110809
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           sun-txw2
Summary:        Typed XML writer
Url:            https://txw.dev.java.net/
Version:        20110809
Release:	2%{?dist}
Epoch:          0
License:        CDDL
Group:          Development/Libraries/Java
BuildArch:      noarch
Source0:        txw2-project-20110809.tgz
# svn export https://svn.java.net/svn/jaxb~version2/tags/txw2-project-20110809/
# tar czf ../SOURCES/txw2-project-20110809.tgz txw2-project-20110809/
Source1:        http://download.java.net/maven/2/com/sun/xml/txw2/txw2/20070624/txw2-20070624.pom
Source2:        sun-txw2-jpp-depmap.xml
Source3:        sun-txw2-settings.xml
Source4:        http://repo1.maven.org/maven2/net/java/jvnet-parent/1/jvnet-parent-1.pom

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 2.0.8
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  forge-parent

BuildRequires:  args4j10
BuildRequires:  javatools-package-rename-task
BuildRequires:  msv-xsdlib
BuildRequires:  relaxngDatatype
BuildRequires:  rngom
BuildRequires:  stax_1_0_api
BuildRequires:  sun-codemodel
BuildRequires:  sun-xsom
Requires:       java >= 0:1.6.0
Requires:       stax_1_0_api
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
TXW is a library that allows you to write XML documents. 
TXW has the following benefits compared to the other XML 
writer libraries:
1. TXW gets rid of string constants for element/attribute 
   names. Those constant names become method names.
2. TXW manages the namespace binding for you. It automatically 
   declares the necessary URIs.
3. TXW allows you to use typed values (such as ints, booleans, 
   or QNames), eliminating cumbersome String.valueOf or the
   use of toString methods.
4. TXW allows you to stream the writing process (IOW, it starts 
   generating pieces as soon as data is available), while at
   the same time allowing you to work out-of-order when you need to.
5. TXW is very small (<50KB)
6. TXW allows you to control various low-level aspects of XML
   writing, such as comments, PIs, and prefix assignments. 

%package compiler
Summary:        Compiler from %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       ant
Requires:       args4j10
Requires:       relaxngDatatype
Requires:       rngom
Requires:       sun-codemodel
Requires:       sun-xsom

%description compiler
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%prep
%setup -q -n txw2-project-20110809

%build
cp %{SOURCE3} maven2-settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/net/java/jvnet-parent/1/
cp %{SOURCE4} $MAVEN_REPO_LOCAL/net/java/jvnet-parent/1/jvnet-parent-1.pom

mvn-jpp \
        -e \
        -s $(pwd)/maven2-settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 runtime/target/txw2-20110809.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 compiler/target/txwc2-20110809.jar $RPM_BUILD_ROOT%{_javadir}/sun-txwc2-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 runtime/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap com.sun.xml.txw2 txw2 %{cvsdate} JPP %{name}
install -m 644 compiler/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-sun-txwc2.pom
%add_to_maven_depmap com.sun.xml.txw2 txwc2 %{cvsdate} JPP sun-txwc2
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-sun-txw2-project.pom
%add_to_maven_depmap com.sun.xml.txw2 txw2-project %{cvsdate} JPP sun-txw2-project


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} 

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 license.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%{_javadir}/%{name}*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%doc %{_docdir}/%{name}-%{version}

%files compiler
%defattr(-,root,root)
%{_javadir}/sun-txwc2*.jar

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Thu Jun 14 2012 Ralph Apel <r.apel@r-apel.de> 20110809-2
- Avoid FileDigest and PayloadIsXz problems on EL5

* Mon Jun 11 2012 Ralph Apel <r.apel@r-apel.de> 20110809-1
- Build 20110809 with maven for JPP-6

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 0.1-0.%{cvsdate}.2
- Auto rebuild for JPackage 5 in mock

* Tue Mar 11 2008 Ralph Apel <r.apel at r-apel.de> 0:0.1-0.20070624.1jpp
- First release
